#pragma once

#include "Value.h"

#include <string>

namespace Databoard {
	namespace Value {

		class DATABOARD_API OptionalValue : public Value {
		public:
			OptionalValue(Databoard::Type::DataType* dataBoard);
			virtual ~OptionalValue();

			virtual std::string writeOut(int indent = 0);
			virtual bool equals(const Value* other);

			void setValue(Value* value);
			void setNoValue();

			// Get the value or null if value doesn't exist
			Value* getValue();
			bool hasValue();

			virtual std::string isValid();


		protected:

			Value* value;

		};
	}
}
