#pragma once

#include <string>

#include "DataType.h"

#include <climits>

namespace Databoard {
	class Range;

	namespace Type {

		class DATABOARD_API StringType : public DataType {
		public:
			StringType();
			StringType(std::string pattern);
			StringType(std::string pattern, std::string mimeType, Range* length);

			virtual ~StringType();

			std::string getPattern();
			void setPattern(std::string pattern);
			std::string getMimeType();
			void setMimeType(std::string mimeType);
			Range* getLength();
			void setLength(Range* length);
			int minLength();
			int maxLength();

			virtual std::string writeOut(int indent = 0);

		protected:

			std::string pattern;
			std::string mimeType;
			Range* length;

		};
	}
}
