#include "ValueParser.h"

#include "DataBoardRepository.h"
#include "DataValueRepository.h"

namespace Databoard {
	namespace Value {

		void parse(std::string fileName, Databoard::Value::DataValueRepository* &dataValueRepository, Databoard::Type::DataBoardRepository* dataBoardRepository)
		{
			if(dataValueRepository == NULL)
			{
				dataValueRepository = new DataValueRepository();
			}

			if(dataBoardRepository != NULL)
			{
				dataValueRepository->open(fileName, dataBoardRepository);
			}
		}

		DATABOARD_API Databoard::Value::Value* parse(std::string fileName, Databoard::Type::DataType* dataType)
		{
			if(dataType != NULL)
			{
				Databoard::Value::DataValueRepository* dataValueRepository = new DataValueRepository();

				Databoard::Value::Value* value = dataValueRepository->open(fileName, dataType);

				delete dataValueRepository;
				dataValueRepository = 0;

				return value;
			}

			return NULL;
		}


		void free(DataValueRepository* dataValueRepository)
		{
			if(dataValueRepository != NULL)
			{
				delete dataValueRepository;
			}
		}
	}
}
