/*******************************************************************************
 *  Copyright (c) 2010 Association for Decentralized Information Management in
 *  Industry THTH ry.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 *
 *  Contributors:
 *      VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.databoard.binding.mutable;

public class MutableByte extends Number implements Comparable<MutableByte> {

	private static final long serialVersionUID = 1L;
	
	public byte value;
	
	public MutableByte() {}
	
	public MutableByte(byte value) { this.value = value; }

	@Override
	public double doubleValue() {
		return value;
	}

	@Override
	public float floatValue() {
		return value;
	}

	@Override
	public int intValue() {
		return value;
	}

	@Override
	public long longValue() {
		return value;
	}
	
	public String toString() {
		return String.valueOf((int) value);
	}

	public int hashCode() {
		return (int) value;
	}

	public boolean equals(Object obj) {
		if (obj instanceof MutableByte) {
			return value == ((MutableByte) obj).byteValue();
		}
		return false;
	}

	public int compareTo(MutableByte anotherByte) {
		return this.value - anotherByte.value;
	}	
	
}

