/*******************************************************************************
 *  Copyright (c) 2010 Association for Decentralized Information Management in
 *  Industry THTH ry.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 *
 *  Contributors:
 *      VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.databoard.util;

import org.simantics.databoard.binding.Binding;
import org.simantics.databoard.binding.error.BindingConstructionException;
import org.simantics.databoard.bindingscheme.BindingScheme;
import org.simantics.databoard.type.DataType;

/**
 * Binding constructor for a single data type.
 *
 * @author Toni Kalajainen <toni.kalajainen@vtt.fi>
 */
public class SingleBinding implements BindingScheme {

	Binding binding;
	
	public SingleBinding(Binding binding)
	{
		this.binding = binding;
	}
	
	@Override
	public Binding getBinding(DataType type2) 
	throws BindingConstructionException 
	{
		DataType type = binding.type();
		if (type2 == type || type2.equals(type)) return binding;				
		throw new BindingConstructionException("Could not create binding for the type");
	}

	@Override
	public boolean supportsType(DataType type) {
		return type == binding.type() || binding.type().equals(type);				
	}

}

